CON

  _clkmode  = xtal1 + pll16x 
  _xinfreq  = 5_000_000

                       
  X_STEP    = 0   '4 parallel port pins INPUTS  0-5
  X_DIR     = 1   '5
  Y_Step    = 2   '6
  Y_Dir     = 3   '7
  Z_Step    = 4   '8
  Z_Dir     = 5   '9
 
  coilX1       = 6  'a red
  coilX2       = 7  'b blue        
  coilX3       = 8  'c green
  coilX4       = 9  'd black
  
  coilY1       = 10 'a red   
  coilY2       = 11 'b blue  
  coilY3       = 12 'c green 
  coilY4       = 13 'd black
  
  coilZ1       = 14 'a red   
  coilZ2       = 15 'b blue  
  coilZ3       = 16 'c green 
  coilZ4       = 17 'd black
  
  X_EncA    = 18 'quadrature encoder INPUTS  18-23
  X_EncB    = 19
  Y_EncA    = 20
  Y_EncB    = 21
  Z_EncA    = 22
  Z_EncB    = 23



  
  Debug_LED = 24    'OUTPUT P24 LED
  Dis_Mtr   = 25    'Parallel Port Pin16 stop motors from Mach3       INPUT 25
  move_ena  = 26    'OUTPUT Parallel Port Pin 10  enables Mach3  Inverted out!!!!
  PwmClk    = 27    'OUTPUT P27  PWM Clock                       
  
  unused28  = 28  
  unused29  = 29
  unused30  = 30
  unused31  = 31


VAR
  LONG Pos[3]         'encoder var's
  long cogNo

OBJ
   Encoder : "Rotary Encoder"             
   Pwm     : "Pwm"
   driver  : "CNC"

'' The start routine has been completely redone.  In particular, it never really needed the
'' several different cogs because "CNC", "Rotary Encoder", and "Pwm" all start their own cogs.
'' The error compare routine is included here rather than putting it in a separate cog for no
'' particular reason and also occupies its own cog once started.  The main cog, after the
'' initialization of the other cogs, continues and does the checking for timeout and position
'' out of bounds.

PUB START
   driver.start( 0, 0, 0)                                             
   PWM.start(27, 50, 200) 
   waitcnt(10_000_000 + cnt)
   doCompare(move_ena,-1,1,driver.posBuffer,@pos)
   driver.resetX
   driver.resetY
   driver.resetZ
   Encoder.Start(18, 3, 0, @Pos)


   'repeat                                                                         
  '  if driver.timestep >  2000   'A = no X travel                                    E = outa[move_ena] = 0 always
  '    driver.timestop            'A = no X travel                                    E = outa[move_ena] = 0 always
   ' if driver.xPosValue > 66000  '                 B =  no Y                         E = outa[move_ena] = 0 always
   '   driver.stop                '                 B =  no Y                         E = outa[move_ena] = 0 always
   ' if driver.yPosValue > 66000  '                 B =  no Y   C = no Y              E = outa[move_ena] = 0 always
   '   driver.stop                 '                B =  no Y   C = no Y              E = outa[move_ena] = 0 always
   ' if driver.zPosValue > 66000   '                B =  no Y   C = no Y  D = all OK  E = outa[move_ena] = 0 always
   '   driver.stop                 '                B =  no Y   C = no Y  D = all OK  E = outa[move_ena] = 0 always

PRI doCompare(moveEnaPin, lower, upper, driverBuf, encoderBuf)
  cogNo := cognew(@compareEntry,@moveEnaPin) + 1            ' Start assembly routine with parameters

DAT
compareEntry           mov      temp1,PAR
                       rdlong   temp2,temp1                 ' Get number of enable pin
                       mov      enaPin,#1
                       shl      enaPin,temp2                ' Convert to a bit mask
                       add      temp1,#4
                       rdlong   lowBnd,temp1                ' Get lower bound of position error
                       add      temp1,#4
                       rdlong   highBnd,temp1               ' Get upper bound of position error
                       add      temp1,#4
                       rdlong   driverPtr,temp1             ' Get address of driver position info
                       add      temp1,#4
                       rdlong   encoderPtr,temp1            ' Get address of encoder position info
                       mov      OUTA,enaPin
                       mov      DIRA,enaPin                 ' Output a high to enable pin
:startLoop             movs     :checkLoop,driverPtr
                       movs     :fetchDriver,encoderPtr     ' Starting values for pointers
                       mov      count,#3
:checkLoop             rdlong   temp1,#0-0                  ' Get driver value and
                       shl      temp1,#1                    '  multiply by two
                       add      :checkLoop,#4
:fetchDriver           rdlong   temp2,#0-0                  ' Get encoder position
                       add      :fetchDriver,#4
                       sub      temp1,temp2                 ' Subtract the two values
                       cmps     temp1,lowBnd          wc
          if_c         mov      OUTA,#0                     ' Disable if difference < lowBnd
                       cmps     highBnd,temp1         wc
          if_c         mov      OUTA,#0                     ' Disable if difference > highBnd
                       djnz     count,#:checkLoop
                       jmp      #:startLoop                 ' Start over again with xPos

temp1                  long     0
temp2                  long     0
count                  long     0
enaPin                 long     0                           ' I/O mask for enable pin
lowBnd                 long     0                           ' Lower bound of error difference
highBnd                long     0                           ' Upper bound of error difference
driverPtr              long     0                           ' Address of driver's first value
encoderPtr             long     0                           ' Address of encoder's first value